import {
  JsonController,
  Param,
  Body,
  Get,
  Post,
  Put,
  Delete,
} from "routing-controllers";
import { getConnectionManager, Repository } from "typeorm";
import {
  EntityFromParam,
  EntityFromBody,
} from "typeorm-routing-controllers-extensions";
import { Track } from "../models/Track";

@JsonController("/track")
export class TrackController {
  private trackRepository: Repository<Track>;

  constructor() {
    this.trackRepository = getConnectionManager().get().getRepository(Track);
  }

  @Get("/track")
  async getAll() {
    return await this.trackRepository.find();
  }

  @Get("/track/:id")
  async getOne(@EntityFromParam("id") track: Track) {
    return track;
  }

  @Post("/track")
  post(@EntityFromBody() track: Track) {
    return this.trackRepository.save(track);
  }

  @Put("/track/:id")
  put(@Param("id") id: number, @Body() user: any) {
    return "Updating a user...";
  }

  @Delete("/track/:id")
  remove(@EntityFromParam("id") track: Track) {
    return this.trackRepository.delete(track);
  }
}
